<?php
//
// Definition of eZProcess class
//
// Created on: <16-Apr-2002 10:53:33 amos>
//
// SOFTWARE NAME: eZ publish
// SOFTWARE RELEASE: 3.7.5
// BUILD VERSION: 15256
// COPYRIGHT NOTICE: Copyright (C) 1999-2006 eZ systems AS
// SOFTWARE LICENSE: GNU General Public License v2.0
// NOTICE: >
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of version 2.0  of the GNU General
//   Public License as published by the Free Software Foundation.
// 
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
// 
//   You should have received a copy of version 2.0 of the GNU General
//   Public License along with this program; if not, write to the Free
//   Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//   MA 02110-1301, USA.
//
//

/*!
  \class eZProcess ezprocess.php
  \ingroup eZUtils
  \brief Executes php scripts with parameters safely

*/

include_once( "lib/ezutils/classes/ezdebug.php" );

class eZProcess
{
    function eZProcess()
    {
    }

    function run( $file, $Params = array(), $params_as_var = false )
    {
        if ( isset( $this ) and
             get_class( $this ) == "ezprocess" )
            $instance =& $this;
        else
            $instance =& eZProcess::instance();
        return $instance->runFile( $Params, $file, $params_as_var );
    }

    /*!
     Helper function, executes the file.
     */
    function &runFile( &$Params, $file, $params_as_var )
    {
        if ( $params_as_var )
        {
            foreach ( $Params as $key => $dummy )
            {
                if ( $key != "Params" and
                     $key != "this" and
                     $key != "file" and
                     !is_numeric( $key ) )
                    ${$key} =& $Params[$key];
            }
        }

        if ( file_exists( $file ) )
        {

            $includeResult = include( $file );
            if ( !isset( $Result ) and $includeResult != 1 )
                $Result = $includeResult;
        }
        else
            eZDebug::writeWarning( "PHP script $file does not exist, cannot run.",
                                   "eZProcess" );
        return $Result;
    }

    function &instance()
    {
        $instance =& $GLOBALS["eZProcessInstance"];
        if ( get_class( $instance ) != "ezprocess" )
        {
            $instance = new eZProcess();
        }
        return $instance;
    }
}

?>
